#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "messages.h"
#include "global.h"

void r_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int    item, i, j, k;
  int    arow, acol, nrow, ncol;
  int    toadd;
  char   buf[100];
  String wert;
  String *lcol, *lrow;
  short  *colwidth;

  void   sort_reg();
  void   clear_reg();
  extern void showmess(Widget widget, char *title, char *text);

  item=(int) client_data;
  switch(item) {
  case 0:      // cut;
    sort_reg();
    if (reg.is_full) clear_reg();
    reg.nrow=reg.row2-reg.row1+1;
    reg.ncol=reg.col2-reg.col1+1;
    reg.ndata=reg.nrow * reg.ncol;
    reg.data=(String *)realloc(reg.data, reg.ndata*sizeof(String));
    k=0;
    for (i=reg.col1; i<=reg.col2; i++)
      for (j=reg.row1; j<=reg.row2; j++) {
	wert=XbaeMatrixGetCell(StatData,j,i);
	reg.data[k]=new char[strlen(wert)+1];
	strcpy(reg.data[k], wert);
	XbaeMatrixSetCell(StatData,j,i,"");
	k++;
      }
    reg.is_full=1;
    XtSetSensitive(mymenu.region.paste, True);
    break;
  case 1:      // copy;
    sort_reg();
    if (reg.is_full) clear_reg();
    reg.nrow=reg.row2-reg.row1+1;
    reg.ncol=reg.col2-reg.col1+1;
    reg.ndata=reg.nrow * reg.ncol;
    reg.data=(String *)realloc(reg.data, reg.ndata*sizeof(String));
    k=0;
    for (i=reg.col1; i<=reg.col2; i++)
      for (j=reg.row1; j<=reg.row2; j++) {
	wert=XbaeMatrixGetCell(StatData,j,i);
	reg.data[k]=new char[strlen(wert)+1];
	strcpy(reg.data[k], wert);
	k++;
      }
    reg.is_full=1;
    XtSetSensitive(mymenu.region.paste, True);
    break;
  case 2:      // paste;
    XbaeMatrixGetCurrentCell(StatData, &arow, &acol);
    XtVaGetValues(StatData,XmNcolumns, &ncol, NULL);
    XtVaGetValues(StatData,XmNrows, &nrow, NULL);
    if (nrow<arow+reg.nrow) {
      /* add rows */
      toadd=arow+reg.nrow-nrow;
      lrow=(String *)XtMalloc(toadd*sizeof(String));
      for (i=0; i<toadd; i++) {
	sprintf(buf, "%d", nrow+i+1);
	lrow[i]=(String) XtNewString(buf);
      }
      XbaeMatrixAddRows(StatData, nrow, NULL, lrow,  NULL, toadd);
      XtVaSetValues(StatData, XmNrowLabelWidth, (short)floor(log10(nrow+toadd))+1, NULL);
      sort.nsort=0; sort.ngroup=1; sort.group[0]=nrow+toadd;
      for (i=0; i<toadd; i++) XtFree(lrow[i]);
      XtFree((char *) lrow);
    }
    if (ncol<acol+reg.ncol) {
      /* add cols */
      toadd=acol+reg.ncol-ncol;
      lcol=(String *)XtMalloc(toadd*sizeof(String));
      colwidth=new short [toadd];
      for (i=0; i<toadd; i++) {
	colwidth[i]=COLWIDTH;
	last_var_num++;
	sprintf(buf, "Var%d", last_var_num);
	lcol[i]=(String) XtNewString(buf);
      }
      XbaeMatrixAddColumns(StatData, ncol, NULL, lcol, colwidth, NULL,  NULL, NULL, NULL, toadd);
      for (i=0; i<toadd; i++) XtFree(lcol[i]);
      XtFree((char *) lcol);
      delete [] colwidth;
    }
    k=0;
    for (i=acol; i<acol+reg.ncol; i++)
      for (j=arow; j<arow+reg.nrow; j++) {
	XbaeMatrixSetCell(StatData, j, i, reg.data[k]);
	k++;
      }
    XbaeMatrixEditCell(StatData, arow, acol);
    break;
  case 3:      // transpose;
    sort_reg();
    if ((reg.row2-reg.row1)==(reg.col2-reg.col1)) {
      /* transpose */
      for (i=reg.row1; i<=reg.row2; i++)
	for (j=reg.col1+i-reg.row1+1; j<=reg.col2; j++) {
	  wert=XbaeMatrixGetCell(StatData, i, j);
	  strcpy(buf,wert);
	  XbaeMatrixSetCell(StatData, i, j,
			    XbaeMatrixGetCell(StatData,
					      reg.row1+j-reg.col1,
					      reg.col1+i-reg.row1));
	  XbaeMatrixSetCell(StatData,
			    reg.row1+j-reg.col1,
			    reg.col1+i-reg.row1,
			    buf);
	}
    }
    else {
      /* error message */
      showmess(StatData, REG_TRANS_T, REG_TRANS_M);
    }
    break;
  }
}

void sort_reg() {
  int h;
    if (reg.col1>reg.col2) {
      h=reg.col1; reg.col1=reg.col2; reg.col2=h;
    }
    if (reg.row1>reg.row2) {
      h=reg.row1; reg.row1=reg.row2; reg.row2=h;
    }
}

void clear_reg() {
  int i;
  for (i=0; i<reg.ndata; i++) delete[]reg.data[i];
  reg.ndata=0; reg.nrow=0; reg.ncol=0; reg.is_full=0;
  XtSetSensitive(mymenu.region.paste, False);
}
